/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VIsFormRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VIsForm extends TableImpl<VIsFormRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_is_form</code>
     */
    public static final VIsForm V_IS_FORM = new VIsForm();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VIsFormRecord> getRecordType() {
        return VIsFormRecord.class;
    }

    /**
     * The column <code>common_dd.v_is_form.key_element</code>.
     */
    public final TableField<VIsFormRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_is_form.dn</code>.
     */
    public final TableField<VIsFormRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    private VIsForm(Name alias, Table<VIsFormRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VIsForm(Name alias, Table<VIsFormRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_is_form" as  SELECT t_core_element_hierarchy.key_element,
          t_core_element_hierarchy.dn
         FROM (common_dd.t_core_element_hierarchy
           RIGHT JOIN common_dd.t_input_webform ON ((t_input_webform.fk_form = t_core_element_hierarchy.key_element)))
        WHERE (t_core_element_hierarchy.key_element IS NOT NULL);
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_is_form</code> table reference
     */
    public VIsForm(String alias) {
        this(DSL.name(alias), V_IS_FORM);
    }

    /**
     * Create an aliased <code>common_dd.v_is_form</code> table reference
     */
    public VIsForm(Name alias) {
        this(alias, V_IS_FORM);
    }

    /**
     * Create a <code>common_dd.v_is_form</code> table reference
     */
    public VIsForm() {
        this(DSL.name("v_is_form"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VIsForm as(String alias) {
        return new VIsForm(DSL.name(alias), this);
    }

    @Override
    public VIsForm as(Name alias) {
        return new VIsForm(alias, this);
    }

    @Override
    public VIsForm as(Table<?> alias) {
        return new VIsForm(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsForm rename(String name) {
        return new VIsForm(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsForm rename(Name name) {
        return new VIsForm(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsForm rename(Table<?> name) {
        return new VIsForm(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsForm where(Condition condition) {
        return new VIsForm(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsForm where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsForm where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsForm where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsForm where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsForm where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsForm where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsForm where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsForm whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsForm whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
